#include "Graph.h"

/*
	Constructor
*/
Graph::Graph(int n, bool oriented) {
	this->numNodes = n;
	this->oriented = oriented;
	for (int i = 0; i < numNodes; i++) {
		neigh.push_back(vector<int>());
	}
}

/* 
	Adds an edge to the graph (both ways if unoriented)
*/
void Graph::addEdge(int i, int j) {
	neigh[i].push_back(j);
	if (!oriented) {
		neigh[j].push_back(i);
	}
}

/*
	Checks if two nodes are connected by an edge
*/
bool Graph::isEdge(int i, int j) {
	vector<int> v = neigh[i];
	return std::find(v.begin(), v.end(), j) != v.end();
}

void Graph::connectedComponents() {

	/* TODO Initializations */
	
	/* 
		TODO Call dfs for all unvisited nodes
		
		Use: components.push_back(vector<int>());
			to create new component
	*/
}

void Graph::dfs(int node, vector<bool>& visited) {
	/*
		TODO Perform dfs
			To add node to component use:
			components[numConnectedComp].push_back(node);
	*/
}

stack<int> Graph::minPath(int source, int dest) {
	vector<bool> visited;
	std::queue<int> q;
	vector<int> dist;
	vector<int> parent;
	parent.resize(numNodes + 1);
	
	/* TODO Initializations */
	
	/*
		TODO Perform BFS from source, keeping track of distance and parent
	*/
	stack<int> path;
	
	// There is no path from source to destination
	if (parent[dest] == -1) {	
		return path;
	}
	/*
		TODO Start from destination, node becomes its parent and gets
		pushed onto the stack while source is not reached
	*/
	return path;
}

/*
	Comparator for finTime used in topologicalSort
*/
struct comp {
	vector<int> finTime;
	comp(vector<int>& finTime) {
		this->finTime = finTime;
	}
	bool operator()(int i, int j) const {
		return finTime[i] > finTime[j];
	}
};

vector<int> Graph::topSort() {
	vector<bool> visited;
	vector<int> topSortOrder;
	finTime.resize(numNodes + 1);
	for (int i = 0; i < numNodes; i++) {
		/*
			TODO Initialize visited
		*/
		topSortOrder.push_back(i);
	}
	
	/*
		TODO Call dfsTopSort for each unvisited node
	*/
	
	comp c(finTime);
	
	// Nodes sorted in descending order by finTime
	sort(topSortOrder.begin(), topSortOrder.end(), c);
	return topSortOrder;
}
void Graph::dfsTopSort(int n, vector<bool>& visited) {
	/* 
		TODO Perform DFS keeping track of finTime
	*/
}

bool Graph::isBipartite(pair<vector<int>, vector<int> >& p) {
	vector<int> sides[2];
	vector<Tag> tag;
	queue<int> q;
	vector<int> neighbors;
	q.push(0);
	tag.resize(numNodes + 1);
	/*
		TODO Initialize all tags with UNDEFINED
	*/
	
	tag[0] = PAR;
	
	/*
		TODO Perform BFS, marking the tags accordingly
	*/
	
	/*
		TODO sides[0] will contain nodes with PAR tag and sides[1]
		the nodes with IMPAR tag
		
		To add node to one side: sides[x].push_back(node);
	*/
	p = make_pair(sides[0], sides[1]);
	return true;
}
void Graph::hamiltonianCycles() {
	vector<bool> included;
	vector<int> path;
	for (int i = 0; i < numNodes; i++) {
		path.push_back(-1);
		included.push_back(false);
	}
	/*
		TODO Start constructing path from node 0
	*/
}
 
bool Graph::buildPath(vector<int>& path, vector<bool>& included, int length) {
	/*
		TODO Check if path represents a hamiltonian cycle and add it to the list:
				hamCycles.push_back(path);
		
			Otherwise try to include each node to the path.
			
			Path already has the right size, use [] operator not push_back!
	*/
	return false;
}
